#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: yum-update_repos.pl, v1.0.0-0 Tue 11 Aug 2009 12:23:21 PM CEST mstauber Exp $
# Copyright 2006-2009 Solarspeed Ltd. All rights reserved.

# This handler is run whenever repositories are enabled or disabled in the GUI.

# Location of Repository files:
$repo_base_cf = "/etc/yum.repos.d/Aventurin-Base.repo";
$repo_ost_cf = "/etc/yum.repos.d/Aventurin-OS-Templates.repo";
$repo_osupdates_cf = "/etc/yum.repos.d/Aventurin-OS-Updates.repo";

#
#### No configureable options below!
#

use CCE;
use Data::Dumper;
use Sauce::Util;

my $cce = new CCE;
my $conf = '/var/lib/cobalt';

$cce->connectfd();

# Get our events from the event handler stack:
$oid = $cce->event_oid();
$obj = $cce->event_object();

$old = $cce->event_old();
$new = $cce->event_new();

# Get Object data from CODB:
($ok, $yum_settings) = $cce->get($oid, 'yum');
$SYSTEM_OID = $oid;

# Variable cleanup:
$repo_base_status = $yum_settings->{"repo_base"};
$repo_ost_status = $yum_settings->{"repo_ost"};
$repo_osupd_status = $yum_settings->{"repo_osupdates"};

# We're creating or modifying the System object:
if ($cce->event_is_modify()) {

    # Base:
    if (-f $repo_base_cf) {
	# Edit config:
	$cfile = $repo_base_cf;
	$changevalue = $repo_base_status;
	&edit_conf_ave;
    }

    # OST:
    if (-f $repo_ost_cf) {
	# Edit config:
	$cfile = $repo_ost_cf;
	$changevalue = $repo_ost_status;
	&edit_conf_ave;
    }

    # OS-Updates:
    if (-f $repo_osupdates_cf) {
	# Edit config:
	$cfile = $repo_osupdates_cf;
	$changevalue = $repo_osupd_status;
	&edit_conf_ave;
    }

}

$cce->bye('SUCCESS');
exit(0);

sub edit_conf_ave {
    if (!Sauce::Util::replaceblock($cfile,
        '# Begin - Do not remove this comment!',
        "enabled=$changevalue",
        '# End - Do not remove this comment!')
        ) {
        $cce->warn('[[base-swupdate.cantEditFile]]', { 'file' => $cfile });
        $cce->bye('FAIL');
    }
}


$cce->bye('SUCCESS');
exit(0);

